header
lorom

!ExtndFreespace1 = $2A8000	;Freespace for DMA hijack code

!ExtndFreespace2 = $2AFFF8	;Freespace to put the left tile graphics. Best when put
				;in this format: xxFFF8

!ExtndFreespace3 = $2CFFF8	;Freespace to put the right tile graphics. Best when put
				;in this format: xxFFF8

!NormVRAM = $6000	;Ignore the first and last number. The middle two numbers are the
			;tile where you want Mario's top left tile to be uploaded. 16x16

!NormVRAM2 = $6020	;Same as above, but for the bottom left tile. Also 16x16

!VRAMLoc = $6200	;Ignore the first and last number. The middle two numbers are the
			;tile where you want Mario's top right tile to be uploaded. 16x16

!VRAMLoc2 = $6220	;Same as above, but for the bottom right tile. Also 16x16


!ROMLoc = $8000		;Must be 8 bytes more than !ExtndFreespace2 AND !ExtndFreespace3

!ROMBank = $2B		;The bank number where the left tiles are in. To get this, add 8 to
			;!ExtndFreespace2, and use the first two bytes in the address.

!ROMBank2 = $2D		;The bank number where the right tiles are in. To get this, add 8 to
			;!ExtndFreespace3, and use the first two bytes in the address.


org $00A300
JML BEGINDMA


org !ExtndFreespace1
db "STAR"
dw ENDMA-BEGINDMA-$01
dw ENDMA-BEGINDMA-$01^$FFFF

BEGINDMA:
REP #$20
LDX #$04
LDY $0D84
BEQ CODE_00A328

;;
;Mario's Palette
;;

LDY #$86
STY $2121
LDA #$2200
STA $4320
LDA $0D82
STA $4322
LDY #$00
STY $4324
LDA #$0014
STA $4325
STX $420B

CODE_00A328:

LDY #$80
STY $2115
LDA #$1801
STA $4320




SEP #$20
LDA $0100
CMP #$14
BEQ ContinUpload
CMP #$07
BEQ ContinUpload
CMP #$0E
BEQ ContinUpload
CMP #$0D
BEQ ContinUpload
CMP #$0F
BEQ ContinUpload
CMP #$1A
BEQ ContinUpload
CMP #$1B
BEQ ContinUpload
CMP #$1F
BEQ ContinUpload
JMP StopUpload


ContinUpload:
REP #$20


;;
;Misc top tiles
;;

LDA #$6040
STA $2116
LDX #$04
.loop
LDA $0D85,x
STA $4322
LDY #$7E
STY $4324
LDA #$0040
STA $4325
LDY #$04
STY $420B
INX #2
CPX $0D84
BCC .loop

;;
;Misc bottom tiles
;;

LDA #$6140
STA $2116
LDX #$04
.loop2
LDA $0D8F,x
STA $4322
LDY #$7E
STY $4324
LDA #$0040
STA $4325
LDY #$04
STY $420B
INX #2
CPX $0D84
BCC .loop2





;;
;Mario Tile 1
;;

Mariotile1:

LDA #!NormVRAM
STA $2116

SEP #$20
LDA $13E0
STA $00
LDX $19
LDA $00
CLC
ADC DMAGFXtable,x
TAX
LDA Tile1,x
BIT.b #%00001000
BNE .skip
STA $4202
CLC
ADC #$08
STA $02
LDA #$40
STA $4203
STZ $03
REP #$20
LDA #!ROMLoc
CLC
BRA +

.skip
STA $02
SEC
SBC #$08
STA $4202
LDA #$40
STA $4203
LDX #$01
STX $03
REP #$20
LDA #!ROMLoc
CLC
ADC #$4000

+
ADC $4216
STA $4322
LDY #!ROMBank
STY $4324
LDA #$0040
STA $4325
LDY #$04
STY $420B
BRA ++

-
REP #$20
LDA #!ROMLoc
CLC
ADC #$4000
BRA +++



++
LDA #!NormVRAM
CLC
ADC #$0100
STA $2116

SEP #$20
LDA $02
STA $4202
LDA #$40
STA $4203
LDX $03
BNE -
REP #$20
LDA #!ROMLoc
CLC

+++
ADC $4216
STA $4322
LDY #!ROMBank
STY $4324
LDA #$0040
STA $4325
LDY #$04
STY $420B



;;
;Mario Tile 2
;;

Mariotile2:

LDA #!NormVRAM2
STA $2116

SEP #$20
LDX $19
LDA $00
CLC
ADC DMAGFXtable,x
TAX
LDA Tile2,x
BIT.b #%00001000
BNE .skip
STA $4202
CLC
ADC #$08
STA $02
LDA #$40
STA $4203
STZ $03
REP #$20
LDA #!ROMLoc
CLC
BRA +

.skip
STA $02
SEC
SBC #$08
STA $4202
LDA #$40
STA $4203
LDX #$01
STX $03
REP #$20
LDA #!ROMLoc
CLC
ADC #$4000

+
ADC $4216
STA $4322
LDY #!ROMBank
STY $4324
LDA #$0040
STA $4325
LDY #$04
STY $420B
BRA ++

-
REP #$20
LDA #!ROMLoc
CLC
ADC #$4000
BRA +++



++
LDA #!NormVRAM2
CLC
ADC #$0100
STA $2116

SEP #$20
LDA $02
STA $4202
LDA #$40
STA $4203
LDX $03
BNE -
REP #$20
LDA #!ROMLoc
CLC

+++
ADC $4216
STA $4322
LDY #!ROMBank
STY $4324
LDA #$0040
STA $4325
LDY #$04
STY $420B




;;
;Mario Extend Tile 1
;;

MarioExtndtile1:

LDA #!VRAMLoc
STA $2116

SEP #$20
LDX $19
LDA $00
CLC
ADC DMAGFXtable,x
TAX
LDA DMATile1,x
BIT.b #%00001000
BNE .skip
STA $4202
CLC
ADC #$08
STA $02
LDA #$40
STA $4203
STZ $03
REP #$20
LDA #!ROMLoc
CLC
BRA +

.skip
STA $02
SEC
SBC #$08
STA $4202
LDA #$40
STA $4203
LDX #$01
STX $03
REP #$20
LDA #!ROMLoc
CLC
ADC #$4000

+
ADC $4216
STA $4322
LDY #!ROMBank2
STY $4324
LDA #$0040
STA $4325
LDY #$04
STY $420B
BRA ++

-
REP #$20
LDA #!ROMLoc
CLC
ADC #$4000
BRA +++



++
LDA #!VRAMLoc
CLC
ADC #$0100
STA $2116

SEP #$20
LDA $02
STA $4202
LDA #$40
STA $4203
LDX $03
BNE -
REP #$20
LDA #!ROMLoc
CLC

+++
ADC $4216
STA $4322
LDY #!ROMBank2
STY $4324
LDA #$0040
STA $4325
LDY #$04
STY $420B



;;
;Mario Extend Tile 2
;;

MarioExtndtile2:

LDA #!VRAMLoc2
STA $2116

SEP #$20
LDX $19
LDA $00
CLC
ADC DMAGFXtable,x
TAX
LDA DMATile2,x
BIT.b #%00001000
BNE .skip
STA $4202
CLC
ADC #$08
STA $02
LDA #$40
STA $4203
STZ $03
REP #$20
LDA #!ROMLoc
CLC
BRA +

.skip
STA $02
SEC
SBC #$08
STA $4202
LDA #$40
STA $4203
LDX #$01
STX $03
REP #$20
LDA #!ROMLoc
CLC
ADC #$4000

+
ADC $4216
STA $4322
LDY #!ROMBank2
STY $4324
LDA #$0040
STA $4325
LDY #$04
STY $420B
BRA ++

-
REP #$20
LDA #!ROMLoc
CLC
ADC #$4000
BRA +++



++
LDA #!VRAMLoc2
CLC
ADC #$0100
STA $2116

SEP #$20
LDA $02
STA $4202
LDA #$40
STA $4203
LDX $03
BNE -
REP #$20
LDA #!ROMLoc
CLC

+++
ADC $4216
STA $4322
LDY #!ROMBank2
STY $4324
LDA #$0040
STA $4325
LDY #$04
STY $420B

SEP #$20

StopUpload:

JML $00A38F


DMAGFXtable:			;Don't mess with this unless you know what you're doing
db $00,$46,$8C,$46



incsrc ExCharacterTilemaps.asm



ENDMA:


org !ExtndFreespace2
db "STAR"
dw ENDXTND-BEGINXTND-$01
dw ENDXTND-BEGINXTND-$01^$FFFF

BEGINXTND:
incbin LeftGFX.bin
ENDXTND:


org !ExtndFreespace3
db "STAR"
dw ENDXTND-BEGINXTND2-$01
dw ENDXTND-BEGINXTND2-$01^$FFFF

BEGINXTND2:
incbin RightGFX.bin
ENDXTND2: